// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep
#include <vector>

#include "OperatorInstances/HyperelasticLaws/CiarletGeymonat.hpp"

#include "Test/Operators/VariationalInstances/HyperelasticOperator/ExpectedResults.hpp" // IWYU pragma: keep
#include "Test/Operators/VariationalInstances/HyperelasticOperator/ModelSettings.hpp"

// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

namespace MoReFEM::TestNS::HyperelasticOperatorNS
{


    template<>
    std::vector<std::vector<PetscScalar>> GetExpectedMatrixP2P1<HyperelasticLawNS::CiarletGeymonat<time_manager_type>>()
    {
        return std::vector<std::vector<PetscScalar>>{
            { -3.9215125493790875e+06, -4.4535283750937013e+06, 2.4072377544436436e+06,  -7.4610905179539393e+05,
              9.4259436845639721e+05,  2.1021246571934459e+05,  -1.9410567450186072e+06, -2.9628457568886210e+06,
              1.7407540757659532e+06,  3.5882194134034798e+05,  7.5952902981124062e+05,  -5.7474302517632255e+05,
              5.9241167957740296e+06,  3.7510396165382117e+06,  -3.0013751655361182e+06, -6.8493124079527603e+06,
              -9.3354700517310333e+06, 5.4259629883882338e+06,  1.0431306513683651e+07,  1.5619161781008150e+07,
              -8.8973842189772502e+06, 3.3816750914608669e+06,  2.7093714900283874e+06,  -4.8156105915604392e+05,
              -3.0853686011726731e+06, -2.2561238413846418e+06, 4.4177353547268664e+05,  -3.5525609869403727e+06,
              -4.7737282607443929e+06, 2.7291226490558749e+06 },
            { -4.4535283750936994e+06, -9.9683139772579595e+06, 4.4924624424159983e+06,  5.3647081452979334e+05,
              2.3825585955764526e+06,  -8.3818915740312904e+05, -4.6244583551648883e+06, -1.0025671376690665e+07,
              5.0006862332394235e+06,  9.2561533634612581e+05,  1.4590543259078059e+06,  -8.7741217071131722e+05,
              3.7602573991299495e+06,  5.9226116903676558e+06,  -3.5945617560928552e+06, -6.7788945621609092e+06,
              -1.6282688459562827e+07, 7.7921255831230180e+06,  1.5771989048801139e+07,  3.7272605718615443e+07,
              -1.7794341471407179e+07, 2.5473264396436522e+06,  7.3276868993151207e+06,  -2.0428598293433036e+06,
              -1.7794374175994741e+06, -4.5702706508633681e+06, 2.1950817677551047e+06,  -5.9053403284316873e+06,
              -1.3517572765407667e+07, 5.6670083584242370e+06 },
            { 2.4072377544436343e+06,  4.4924624424159937e+06,  -5.4762814925727099e+06, 1.5675457642150897e+05,
              -1.0144941925353056e+06, 9.0040004005096608e+05,  2.6166735204198710e+06,  4.9108591686204104e+06,
              -2.9280405325089931e+06, -8.0878858717182779e+05, -7.7928035443711956e+05, -2.0117387518759016e+06,
              -3.2873807168656439e+06, -3.4469047144507477e+06, 4.0208360443812171e+06,  5.1563842512950636e+06,
              9.5890123876145184e+06,  -7.2527446171205845e+06, -8.9117722277198453e+06, -1.7918269229132246e+07,
              1.3950087996892823e+07,  -1.8116749908387731e+05, -2.0665891132603262e+06, 9.9420742935166657e+06,
              8.1626410764914099e+05,  1.8624903881311470e+06,  -4.4254493243732797e+06, 2.0357948206119761e+06,
              4.3707132170336712e+06,  -6.7191436563902069e+06 },
            { 1.6603370611621132e+06,  1.1088887177433011e+06,  -1.0189350150377072e+06, 4.5412873882472643e+05,
              -2.6452635745175398e+05, -1.5038385080694460e+05, 7.5140176731580193e+05,  6.0421729693574458e+05,
              -5.6387872280630935e+05, -1.6939813107562182e+05, -2.1082681982521288e+05, 1.1239645426798615e+05,
              -2.6354912256430299e+06, -1.1735881625286532e+06, 1.2252246920640592e+06,  3.1482742054345184e+06,
              2.8215811094621238e+06,  -2.2223642986998083e+06, -4.5156866563250963e+06, -3.9415088234768533e+06,
              3.1108621601967039e+06,  -1.6722785572983052e+06, -8.2781340105195064e+05, 7.0055997273620649e+05,
              1.6435757384062959e+06,  5.4730574419641332e+05,  -2.8591832457150047e+05, 1.3351370591985970e+06,
              1.3362706959968421e+06,  -9.0756306734268670e+05 },
            { 2.2147872291984670e+06,  3.2816992684703600e+06,  -1.8915819273878206e+06, -2.6452635745175416e+05,
              -7.9701431509072892e+05, 3.2687142520699796e+05,  2.0991075961707211e+06,  3.2442906557465428e+06,
              -2.0115024589023991e+06, -4.1836649593855173e+05, -4.9502498117345688e+05, 4.3275399827465805e+05,
              -1.8825809026489570e+06, -1.8900274972561789e+06, 1.5578256995889773e+06,  3.3497072620302802e+06,
              5.6345627213256909e+06,  -3.2988036862738440e+06, -7.4448570481871665e+06, -1.2471154012379348e+07,
              7.5088632985104192e+06,  -1.0575020472254776e+06, -2.3674472562108277e+06, 6.9208453290055541e+05,
              7.2817233174855902e+05,  1.6790285170643041e+06,  -9.8050512779685389e+05, 2.6760584323038789e+06,
              4.1810868995036413e+06,  -2.3360057541206926e+06 },
            { -8.7693421112913638e+05, -1.4095677709072737e+06, 1.8371663373636985e+06,  -1.5038385080694396e+05,
              3.2687142520699860e+05,  -2.5375491230133074e+05, -1.0818858278705743e+06, -1.4087136111844748e+06,
              1.0728599204262276e+06,  5.2349904215426848e+05,  1.0737539251789241e+05,  4.8061797954791057e+05,
              1.4226873287828537e+06,  1.1044595365985036e+06,  -1.4329809166518718e+06, -2.3915884483394558e+06,
              -3.1882102358011426e+06, 2.8566428870174936e+06,  3.9763970614885516e+06,  5.3599024688366167e+06,
              -5.0398420720673269e+06, -3.5842967824965157e+05, 1.0710408163584366e+06,  -3.0580675030189212e+06,
              -3.1415681165065180e+05, -6.3773241527908028e+05, 1.5447774899920071e+06,  -7.4920460437925940e+05,
              -1.3254256063464768e+06, 1.9925807896921104e+06 },
            { 1.3259187144429171e+06,  2.2485515426941011e+06,  -1.1807127214253626e+06, 1.7581284653422167e+05,
              -3.3262072584719316e+05, -7.3388229710982239e+04, 7.0945726561476290e+05,  1.5032885153343100e+06,
              -8.5414780613108387e+05, -1.4208605448589288e+05, -3.3640100353543967e+05, 3.0531195759118168e+05,
              -2.0013094491247693e+06, -1.9402503835115465e+06, 1.5651404472340869e+06,  2.4121436749060615e+06,
              4.2147772745054904e+06,  -2.3824085637244578e+06, -3.4832818009755546e+06, -7.4537861180961616e+06,
              4.1104467023140821e+06,  -1.0199265500322073e+06, -1.2642291359017261e+06, 1.9959217832952773e+05,
              7.0806822408987943e+05,  1.1698383991888787e+06,  -3.6412307105898531e+05, 1.3152031290305811e+06,
              2.1908316351692914e+06,  -1.3257108934180057e+06 },
            { 1.2230070214627483e+06,  4.0635707750204164e+06,  -1.8924304331748446e+06, -1.8357374709793352e+05,
              -9.4151987103028619e+05, 3.5520155371238961e+05,  1.5032885153343149e+06,  4.1682239680507341e+06,
              -2.0719679186338161e+06, -2.9494763395698526e+05, -6.6731475414609769e+05, 3.5116397742934409e+05,
              -9.9347764837134304e+05, -2.6455590871199276e+06, 1.3014397564595381e+06,  2.0427138439530900e+06,
              6.7778157104409840e+06,  -3.3085901788380761e+06, -4.9194562663815394e+06, -1.5070375090458371e+07,
              7.2330850959396930e+06,  -9.4880817341712920e+05, -2.9902056321989112e+06, 1.1135107267072261e+06,
              7.4268887446771609e+05,  1.5838600386825872e+06,  -6.7441328072619345e+05, 1.8285652140070624e+06,
              5.7215039427588675e+06,  -2.4069992988752634e+06 },
            { -7.7905255516862008e+05, -1.6699977873808364e+06, 1.8951407692039488e+06,  5.1634221722070679e+03,
              3.3350333524417022e+05,  -2.7201969403550780e+05, -8.5414780613106280e+05, -2.0719679186338079e+06,
              1.2402714189111842e+06,  1.2825493170040377e+05,  5.7841076691191178e+05,  3.9937184089570330e+05,
              9.6918428303541522e+05,  1.6535137816418298e+06,  -1.5125892898244208e+06, -1.7737289609037274e+06,
              -4.0002742585604736e+06, 2.9151292074970487e+06,  2.8472551001459835e+06,  7.2244072724897619e+06,
              -5.3009081027809242e+06, 4.8087529715457128e+05,  1.2823945724899031e+05,  -2.8546654874385153e+06,
              -3.5260481793451234e+05, -4.6919725325860659e+05, 1.0966009158931309e+06,  -6.7119889407065755e+05,
              -1.7066373957029385e+06, 2.3936684216783503e+06 },
            { 9.3525677377405774e+05,  1.0960881146562998e+06,  -2.0759001798057376e+05, 1.1616746643644555e+05,
              -3.4544728515745065e+05, 1.3559614798582021e+04,  4.8019771208804264e+05,  8.5533994461856631e+05,
              -3.2272754682855972e+05, -4.7337755778833234e+04, -2.1230120645058804e+05, 1.5703461331715470e+05,
              -1.2873161210062299e+06, -6.3720107049801154e+05, 2.1101002623797217e+05,  1.2888945276121793e+06,
              2.2991116677634204e+06,  -8.2119012596396776e+05, -2.4323380563829988e+06, -4.2238668394351341e+06,
              1.6760753564664668e+06,  -6.8946998413035460e+05, -6.1732895307471021e+05, -4.1859109190969041e+05,
              7.3372463867649739e+05,  5.3897969799935003e+05,  2.0826786015779927e+05,  9.0222079871119373e+05,
              1.2466259295782587e+06,  -4.9584868829518324e+05 },
            { 1.0157341244324829e+06,  2.6230439337671795e+06,  -7.0845008185333502e+05, -8.8370709980105734e+04,
              -6.4402440945543617e+05, 1.5611617848374107e+05,  1.0220622436598515e+06,  2.6131567528933869e+06,
              -9.1721585570320720e+05, -2.1230120645058880e+05, -2.9671459058825066e+05, 9.3494195007315153e+04,
              -8.8419884810964996e+05, -1.3870251059915486e+06, 7.3529630004433950e+05,  1.3864734561775380e+06,
              3.8703100277961497e+06,  -1.1847317180110994e+06, -3.4076757342324276e+06, -9.7310766157777309e+06,
              3.0523930769570619e+06,  -5.4101621900104533e+05, -1.9700340109053836e+06, 2.3726456973552227e+05,
              3.0857621138319891e+05,  1.3073820951164765e+06,  -5.4016335923205665e+05, 1.4007166821207458e+06,
              3.6149819231451582e+06,  -9.2400330542828154e+05 },
            { -7.5125098814587842e+05, -1.4128968841278870e+06, 1.7439743860050621e+06,  -1.1534147786772060e+04,
              3.5411943208413722e+05,  -3.7462543371412769e+05, -6.8063988641823386e+05, -1.4301776388021272e+06,
              6.1490919317158102e+05,  1.5703461331715554e+05,  9.3494195007315444e+04,  1.1317489314322874e+06,
              8.9550910504737555e+05,  6.8893139621041482e+05,  -1.0752658379049248e+06, -9.9106684205188090e+05,
              -2.4005278932529050e+06, 1.4809725226060420e+06,  2.0881200660853125e+06,  5.3339594878058666e+06,
              -3.6093378220445723e+06, 5.8721880178958032e+04,  8.6730883965289965e+05,  -4.0293413030592306e+06,
              -1.4950247806397697e+05, -7.5556071959345962e+05, 1.7840709184881402e+06,  -6.1539132216205914e+05,
              -1.3386502149842542e+06, 2.3328944450197429e+06 }
        };
    }


    template<>
    std::vector<PetscScalar> GetExpectedVectorP2P1<HyperelasticLawNS::CiarletGeymonat<time_manager_type>>()
    {
        return std::vector<PetscScalar>{ 436739.77654980693,  879636.1457375438,   -314088.82910046773,
                                         20927.338292384688,  -450486.36025578406, 32638.336401190416,
                                         -301778.5985187985,  -154426.93223747006, 62511.76121727971,
                                         -155888.51632339304, -274722.8532442897,  218938.73148199762 };
    }


} // namespace MoReFEM::TestNS::HyperelasticOperatorNS

// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)


// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
